PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
List of all members
PCharArray Class Reference

Array of characters. More...

`#include <array.h>`

Inheritance diagram for PCharArray:
[legend]
Collaboration diagram for PCharArray:
[legend]

## Public Member Functions
Construction
| PCharArray (PINDEX initialSize=0)
| Construct a new dynamic array of char. More...
| PCharArray (char const *buffer, PINDEX length, PBoolean dynamic=true)
| Construct a new dynamic array of char. More...
| PCharArray (PContainerReference &reference_)
Overrides from class PObject
virtual void | PrintOn (ostream &strm) const
| Print the array. More...
virtual void | ReadFrom (istream &strm)
| Read the array. More...
virtual PObject * | Clone () const
| Clone the object. More...
Public Member Functions inherited from PBaseArray< char >
| PBaseArray (PINDEX initialSize=0)
| Construct a new dynamic array of elements of the specified type. More...
| PBaseArray (charconst *buffer, PINDEX length, PBoolean dynamic=true)
| Construct a new dynamic array of elements of the specified type. More...
PBoolean | SetAt (PINDEX index, charval)
| Set the specific element in the array. More...
char | GetAt (PINDEX index) const
| Get a value from the array. More...
void | Attach (const char *buffer, PINDEX bufferSize)
| Attach a pointer to a static block to the base array type. More...
char * | GetPointer (PINDEX minSize=0)
| Get a pointer to the internal array and assure that it is of at least the specified size. More...
char | operator[] (PINDEX index) const
| Get a value from the array. More...
char & | operator[] (PINDEX index)
| Get a reference to value from the array. More...
| operator charconst * () const
| Get a pointer to the internal array. More...
PBoolean | Concatenate (const PBaseArray &array)
| Concatenate one array to the end of this array. More...
Public Member Functions inherited from PAbstractArray
| PAbstractArray (PINDEX elementSizeInBytes, PINDEX initialSize=0)
| Create a new dynamic array of `initalSize` elements of `elementSizeInBytes` bytes each. More...
| PAbstractArray (PINDEX elementSizeInBytes, const void *buffer, PINDEX bufferSizeInElements, PBoolean dynamicAllocation)
| Create a new dynamic array of `bufferSizeInElements` elements of `elementSizeInBytes` bytes each. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two arrays. More...
virtual PBoolean | SetSize (PINDEX newSize)
| Set the size of the array in elements. More...
void | Attach (const void *buffer, PINDEX bufferSize)
| Attach a pointer to a static block to the base array type. More...
void * | GetPointer (PINDEX minSize=1)
| Get a pointer to the internal array and assure that it is of at least the specified size. More...
PBoolean | Concatenate (const PAbstractArray &array)
| Concatenate one array to the end of this array. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
Protected Member Functions inherited from PBaseArray< char >
| PBaseArray (PContainerReference &reference_)
virtual void | PrintElementOn (ostream &stream, PINDEX index) const
Protected Attributes inherited from PAbstractArray
PINDEX | elementSize
| Size of an element in bytes. More...
char * | theArray
| Pointer to the allocated block of memory. More...
PBoolean | allocatedDynamically
| Flag indicating the array was allocated on the heap. More...
Friends inherited from PObject

## Detailed Description

Array of characters.

## Constructor & Destructor Documentation

PCharArray::PCharArray | ( | PINDEX | initialSize = `0` | ) |
| inline

Construct a new dynamic array of char.

The array is initialised to all zero bytes.

Parameters

  initialSize | Initial number of elements in the array.

Referenced by Clone().

PCharArray::PCharArray | ( | char const * | buffer,
|  | PINDEX | length,
|  | PBoolean | dynamic = `true`
| ) |  |
| inline

Construct a new dynamic array of char.

Parameters

  buffer | Pointer to an array of chars.
  length | Number of elements pointed to by `buffer`.
  dynamic | Buffer is copied and dynamically allocated.

PCharArray::PCharArray | ( | PContainerReference & | reference_ | ) |
| inline

## Member Function Documentation

virtual PObject* PCharArray::Clone | ( |  | ) | const
| inline virtual

Clone the object.

Reimplemented from PBaseArray< char >.

Reimplemented in PCaselessString, and PString.

References PContainer::GetSize(), PCharArray(), and PNEW.

virtual void PCharArray::PrintOn | ( | ostream & | strm | ) | const
| virtual

Print the array.

Parameters

  strm | Stream to output to.

Reimplemented from PAbstractArray.

virtual void PCharArray::ReadFrom | ( | istream & | strm | ) |
| virtual

Read the array.

Reimplemented from PAbstractArray.

The documentation for this class was generated from the following file:

- array.h